/* log.h - Routines for logging messages to a file */

#ifndef LOG_H
#define LOG_H

#include "types.h"

extern void log_fatal(const char *err);
extern void log_open(void);
extern void log_printf(const char *ps);
extern void log_line(const char *ps);
extern void log_str(const char *ps);
extern void log_strn(const char *ps, word n);
extern void log_bin(const char *ps, word n);
extern void log_byte(byte b);
extern void log_word(word w);
extern void log_uint(word w);
extern void log_int(int i);
extern void log_close(void);

extern int log_nshow;

#endif
